
with gnat.io; use gnat.io;

procedure multiplex is
   s:integer := 0;

   task type t(id:integer);

   task semaphore is
      entry wait;
      entry signal;
      entry initialsem(n0:in integer);
   end semaphore;

   task body semaphore is
      n:integer:=3;
   begin
      accept initialsem(n0:in integer) do
         n:=n0;
      end initialsem;
      loop
         select
            when n>0 =>
               accept wait do
                  n:=n-1;
                end wait;
         or
            accept signal do
               n:=n+1;
            end signal;
         end select;
      end loop;
   end semaphore;

   task body t is
      i,x:integer := 0;
   begin
      semaphore.wait;

      Put(id);
      x:=0;
      for i in 1..100000 loop
         x:=x+1;
      end loop;
      Put(id);

      semaphore.signal;
   end t;



begin
   semaphore.initialsem(2);

   declare
      task01:t(1);
      task02:t(2);
      task03:t(3);
      task04:t(4);
      task05:t(5);
      task06:t(6);
      task07:t(7);


   begin
      null;
   end;

   abort semaphore;

end multiplex;
