program ReusableBarrierCorrect;

const n=5;

var mutex, barrier,
	 barrier2:semaphore;
	 count:integer;
	 mutex1:semaphore := 1;

procedure P(i:integer);
begin
	repeat
		wait(mutex1); writeln('Rendezvous ',i); signal(mutex1);

		wait(mutex);
			count:=count-1;
			if count=0 then begin
				signal(barrier);
				wait(barrier2);
			end;
		signal(mutex);
	
		wait(barrier);
		signal(barrier);

		wait(mutex1); writeln('Critical point ',i); signal(mutex1);

		wait(mutex);
			count:=count+1;
			if count=n then begin
				signal(barrier2);
				wait(barrier);
			end;
		signal(mutex);

		wait(barrier2);
		signal(barrier2);
	until false;
end;

begin
	initialsem(mutex,1);
	initialsem(barrier,0); 
	initialsem(barrier2,1);
	count:=n;
	cobegin
		P(1); P(2); P(3); P(4); P(5);
	coend;
end.
