SYSTEM sieve;
CONFIGURATION Liste [200];
CONNECTION  (* none *);

SCALAR  prime: integer;
VECTOR  candidate: boolean;

BEGIN
   PARALLEL
      candidate := id_no >= 2;
      WHILE candidate DO
         prime:= REDUCE.First(id_no);
         WRITEINT(prime,10); WRITELN;
         IF id_no MOD prime = 0       (* remove multiples *)
            THEN candidate := FALSE
         END
      END
   ENDPARALLEL
END sieve.
