SYSTEM montecarlo;
CONST intervalle = 1000;

CONFIGURATION list [1..intervalle];
CONNECTION (* none *);

VECTOR val,s: real;
       i:integer;

PROCEDURE f (VECTOR x: real): VECTOR real;
(* function to be integrated *)
BEGIN
  RETURN(4.0 / (1.0 + SIN(x)*SIN(x)))
END f;

BEGIN
   
  PARALLEL
    s:=0.0;
    for i:=1 to 100 do 
      s:=s+f(VRRANDOM());
    end;
    s:=s/100.0;
  ENDPARALLEL;
  WriteReal(REDUCE.sum(s)/1000.0, 15);
END montecarlo.

